/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Pedidos                                                                    */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 2804_PEDTRG_GRAVA_HISTORICO_PEDIDO                                   */
/*                                                                            */
/* Descrio:                                                                 */
/* Gravar o histrico das alteraes da tabela ITEMPEDIDO                     */
/*                                                                            */
/* Criao:                                                                   */
/* 31/08/2006 - Welbert Gonalves Moitinha                                    */
/*@c:\web_605\sql\end_conv\oracle\2804_PEDTRGO_GRAVA_HISTORICO_PEDIDO.SQL     */
/******************************************************************************/
create or replace TRIGGER GRAVA_HISTORICO_PEDIDO
AFTER INSERT OR UPDATE
ON ITEMPEDIDO FOR EACH ROW
BEGIN
   IF INSERTING THEN
      INSERT INTO HISITEMPED
         (CDFILIAL, NRPEDIDO, NRITEMPED, DTHRHIST, IDSITATUHIST,
         IDSITANTHIST, CDOPEMANHIST, CDJUSTEXCHIS, IDALTHISTITE, QTITEMPEDANT, QTITEMPEDATU)
      VALUES
         (:NEW.CDFILIAL, :NEW.NRPEDIDO, :NEW.NRITEMPED, SYSDATE , :NEW.IDSITITEMPED,
          :NEW.IDSITITEMPED, :NEW.CDOPERADOR,  '', '1', NULL, :NEW.QTITEMPED);
   ELSE
      IF (UPDATING) AND (NVL(:OLD.IDSITITEMPED,'W')<> NVL(:NEW.IDSITITEMPED, 'W'))
                    OR  (NVL(:OLD.QTEXPITEMPED, -1)<> NVL(:NEW.QTEXPITEMPED, -1)) THEN
         INSERT INTO HISITEMPED
            (CDFILIAL, NRPEDIDO, NRITEMPED, DTHRHIST, IDSITATUHIST,
            IDSITANTHIST, CDOPEMANHIST,   CDJUSTEXCHIS, IDALTHISTITE, QTITEMPEDANT, QTITEMPEDATU)
         VALUES
            (:NEW.CDFILIAL, :NEW.NRPEDIDO, :NEW.NRITEMPED, SYSDATE , :NEW.IDSITITEMPED,
             :OLD.IDSITITEMPED, :NEW.CDOPERADOR, :NEW.CDJUSTEXCHIS, '1', NULL, NULL);
      END IF;

      IF (UPDATING)AND(NVL(:OLD.QTITEMPED,-1)<> NVL(:NEW.QTITEMPED, -1)) THEN
         INSERT INTO HISITEMPED
            (CDFILIAL, NRPEDIDO, NRITEMPED, DTHRHIST, IDSITATUHIST,
            IDSITANTHIST, CDOPEMANHIST,   CDJUSTEXCHIS, IDALTHISTITE, QTITEMPEDANT, QTITEMPEDATU)
         VALUES
            (:NEW.CDFILIAL, :NEW.NRPEDIDO, :NEW.NRITEMPED, SYSDATE , :NEW.IDSITITEMPED,
             :OLD.IDSITITEMPED, :NEW.CDOPERADOR, :NEW.CDJUSTEXCHIS, '1', :OLD.QTITEMPED, :NEW.QTITEMPED);
     END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_HISTORICO_PEDIDO','5.01.014'); END;
/








